﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim realtime As FirebaseDatabase
	Dim msgref As DatabaseReference
	Public phone As Phone

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

End Sub

Sub Service_Start (StartingIntent As Intent)
	realtime.Initialize("Realtime")
	realtime.PersistenceEnabled = True
	realtime.goOnline

	msgref.Initialize("Reference",realtime.Reference.Child("users/"&phone.GetSettings("android_id")&"/Messages"),"users/"&phone.GetSettings("android_id")&"/Messages")

	Dim qry As FBQuery
	qry.Initialize("QueryResult",msgref.orderByChild("time").QueryObj)
	qry.limitToFirst(3).addListenerForSingleValueEvent

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

#Region Query Result
Sub QueryResult_onDataChange(snapshot As Object, tag As Object)
	Log($"QueryResult_onDataChange()"$)
	If snapshot <> Null Then
		Dim snap As DataSnapshot
		snap.Initialize(snapshot)
		'Log("Snapshot value is NOT null. Ok. Need to check content")
		If snap.Value Is Map Then
			'Log("Value type Map: "& GetType(snap.Value))
			Dim m As Map = snap.Value
			Log(m)
			For Each k As String In m.Keys

				Log(m.Get(k))
			Next
				
			'fbdb = snap.Value
			'Log("FBDBroot set...")
		else if snap.Value Is List Then
			'Log("Value type List: "& GetType(snap.Value))
			Dim customers As List = snap.Value
			Log("referenceListSize: "&customers.Size)
		else if snap.Value Is String Then
			'Log("Value type String: "& GetType(snap.Value))
			Dim val As String = snap.Value
			Log("Value="&val)
		Else
			Log("Value type unknown: "& GetType(snap.Value))
		End If

	Else
		Log("Snapshot is null")
	End If

End Sub
#End Region

#Region FBReference
Sub Reference_onChildAdded(snapshot As Object, child As String, tag As Object)
	Log($"Reference_onChildAdded(${child},${tag})"$)
	Dim snap As DataSnapshot
	snap.Initialize(snapshot)
	Select child
		Case "options"
			'Dim options As Map = snap.Value
			'Log("-------------------")
			'Log("--- OPTIONS -------")
			'Log(options)
			'Log("-------------------")
		Case "geoFire"
		Case "users"
			'Dim users As Map = snap.Value
			'Log("-------------------")
			'Log("--- USERS ---------")
			'Log(users)
			'Log("-------------------")
	End Select
	'Log("-------------------")
	'Log(snap.Key)
	'Log(snap.Value)
	'Log("---_onChildAdded()")
End Sub
Sub Reference_onChildChanged(snapshot As Object, child As String, tag As Object)
	'Log($"Reference_onChildchanged(${child},${tag})"$)
End Sub
Sub Reference_onComplete(resultCode As Int, resultMessage As String, result As Object, tag As Object)
	'Log($"Reference_onComplete(${resultCode},${resultMessage},${tag})"$)
End Sub
Sub Reference_onChildMoved(snapshot As Object, child As String, tag As Object)
	'Log($"Reference_onChildMoved(${child},${tag})"$)
End Sub
Sub Reference_onChildRemoved(snapshot As Object, tag As Object)
	'Log($"Reference_onChildRemoved(${tag})"$)
End Sub
Sub Reference_onDataChange(snapshot As Object, tag As Object)
	Log($"Reference_onDatachange(${tag})"$)
	If snapshot <> Null Then
		Dim snap As DataSnapshot
		snap.Initialize(snapshot)
		'Log("Snapshot value is NOT null. Ok. Need to check content")
		If snap.Value Is Map Then
			'Log("Value type Map: "& GetType(snap.Value))
			Dim m As Map = snap.Value
			Log(m)
			For Each k As String In m.Keys

				Log(m.Get(k))
			Next
				
			'fbdb = snap.Value
			'Log("FBDBroot set...")
		else if snap.Value Is List Then
			'Log("Value type List: "& GetType(snap.Value))
			Dim customers As List = snap.Value
			Log("referenceListSize: "&customers.Size)
		else if snap.Value Is String Then
			'Log("Value type String: "& GetType(snap.Value))
			Dim val As String = snap.Value
			Log("Value="&val)
		Else
			Log("Value type unknown: "& GetType(snap.Value))
		End If

		'users/b0d0d7f9b81140c3/)
		'Dim json As JSONParser
		'json.Initialize(snap.Value)
		'Dim root As Map = json.NextObject
		'Log(json.NextObject)
	Else
		Log("Snapshot is null")
	End If
	'Dim keys As List = snap.Children
	'Log(keys.Size)
	'Log(snap.Children)
End Sub
#End Region
